<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class OperadorRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    /**
     * @return array
     */
    public function getMaxId() {
        //$maxIdQuery = "SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(CDOPERADOR)) + 1), 12, '0') AS MAX_ID FROM OPERADOR";
        $maxIdQuery = "SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(DECODE(REPLACE(TRANSLATE(CDOPERADOR, '0123456789', '##########'), '#', ''), NULL, CDOPERADOR, NULL)))+1), 12, '0') MAX_ID FROM OPERADOR";
        return $this->connection->fetchAll($maxIdQuery);
    }
    
    public function retornaOperadorOrgParcnegocio($params){
    $query = $this->entityManager->getConnection()->prepare("
            SELECT * 
             FROM OPERADOR 
            WHERE
             NRORG = :P_NRORG
            AND NRPARCNEGOCIO = :P_NRPARCNEGOCIO"
        );

        $query->execute($params);

        return $query->fetchAll();
    }

    public function getClientSecret(int $nrOrg): array {
        $sql = <<<SQL
            SELECT CLIENT_SECRET
            FROM ORGANIZACAO
            WHERE NRORG = :P_NRORG
SQL;

        $params = [
            'P_NRORG' => $nrOrg,
        ];

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $result = $std->fetchAll();

        return $result;
    }
} 
