<?php

namespace HCM\PTO\Logic\AFD;

/**
 * Responsavel por permitir a contagem de registros processados
 * 
 * 
 */

abstract class ContadorRegistros {
    /** @var Registro[] */
    private $registros;
    
    public function __construct(array $registros) {
        $this->registros = $registros;
    }
    
    /**
     * Responsavel por filtrar os registros do arquivo por tipos especificos
     * @return int
     */
    public abstract function buscaRegistrosPorTipo(int $numeroTipoRegistro): array;
    
    /**
     * Responsavel por retornar os registros processados
     * @return int
     */
    protected function getRegistros(): array {
        return $this->registros;
    }
    
    /**
     * Responsavel por contar os registros do arquivo por tipos especificos
     * @return int
     */
    public function contaRegistrosPorTipo(int $numeroTipoRegistro): int {
        $registros = $this->buscaRegistrosPorTipo($numeroTipoRegistro);
        return array_reduce($registros, function ($acc, $item) {
            return $acc + $item->quantidadeItensUltimaGeracao();
        }, 0);
    }
}